<?php

namespace Data443\LGPD\Admin;

class AdminNotice {

	protected $template;

	protected $data;

	/**
	 * todo: replace with a proper factory pattern via lgpd()?
	 *
	 * AdminNotice constructor.
	 */
	public function __construct() {
		if ( did_action( 'admin_notices' ) ) {
			trigger_error( 'AdminNotice class called incorrectly - admin_notices action has already ran!', E_USER_ERROR );
		}

		add_action( 'admin_notices', array( $this, 'render' ), 9999 );
	}

	public function add( $template, $data = array() ) {
		$this->template = $template;
		$this->data     = $data;
	}

	public function render() {
		if ( ! $this->template ) {
			trigger_error( 'Template not set for admin notice!', E_USER_ERROR );
		}

		echo lgpd( 'view' )->render( 'admin/notices/header' );
		echo lgpd( 'view' )->render( $this->template, $this->data );
		echo lgpd( 'view' )->render( 'admin/notices/footer' );
	}
}
